<?php
if( !defined( 'MEDIAWIKI' ) ) {
    echo( "This file is an extension to the MediaWiki software and cannot be used standalone.\n" );
    die( 1 );
}

$wgExtensionCredits['hook'][] = array( 
    'name' => 'NozicaaHooks', 
    'author' => 'Cedric Chantepie', 
    'description' => 'Read restriction enforcer',
);

$wgHooks['userCan'][] = 'readRestrCheck';

// Sets up 'read' restriction type
$wgRestrictionTypes[] = 'read';

/**
 * Hook function enforcing group restriction (protection)
 * when checking whether current user can 'read' (view).
 *
 * @param title Current title
 * @param user Current user
 * @param action Required action, only 'read' is checked there
 * @param result
 */
function readRestrCheck(&$title, &$user, $action, &$result) {
  if ($action != "read") {
    // Skips action other than 'read'
    return true;
  }

  // ---

  $restrictions = $title->getRestrictions("read");
  $userGroups = $user->getGroups();
  $allowed = (count($restrictions) == 0) ? true : false;

  foreach ($userGroups as $group) {
    if (in_array($group, $restrictions)) {
      $allowed = true;
      break;
    }
  }

  $result = $allowed;

  return true;
}
